<?php
header("Content-Type: text/html;charset=utf-8");

class cls_Compra {

	private $db_mensaje = "";
	private $db_nombretabla = "compra";
	private $db_nombrevista = "vista_compra";
	private $db_filas = "*";
	private $compra_id = 0;
	private $fecha = "";
	private $operacion = "";
	private $comprobante = "";
	private $numero = "";
	private $proveedor_id = 0;
	private $proveedor_nombre = "";
	private $proveedor_documento_tipo = "";
	private $proveedor_documento_numero = "";
	private $responsable_id = "0";
	private $responsable_nombre = "";
	private $responsable_documento_tipo = "";
	private $responsable_documento_numero = "";
	private $moneda_codigo = "";
	private $moneda_simbolo = "";
	private $moneda_cambio = "";
	private $igv_porcentaje = 0;
	private $estado_registro = "";
	private $observaciones = "";
	private $costo_total = 0;
    private $proveedor_direccion = "";
	private $usuario_modificacion = 0;
	private $fecha_creacion = "";
	private $fecha_modificacion = "";
	private $activo = true;
	
	public function __construct(){
		$this->db_filas = "compra_id, fecha, operacion, comprobante, numero, proveedor_id, proveedor_nombre, proveedor_documento_tipo, proveedor_documento_numero, responsable_id, responsable_nombre, responsable_documento_tipo, responsable_documento_numero, estado_registro, observaciones, costo_total, proveedor_nombre, proveedor_documento_tipo, proveedor_documento_numero, proveedor_direccion, moneda_codigo, igv_porcentaje, usuario_modificacion, fecha_creacion, fecha_modificacion, activo";
	}

	static public function Indice($codigo){
		$current = new cls_Compra();
		$conn = new cls_Conexion();
		$filtro = "compra_id = ?";
		$values = array();
		array_push($values, $codigo );
		$lista = $conn->buscar_datos($current->db_nombrevista, $current->db_filas, $filtro, $values, "");
		$current->db_mensaje = $conn->getMensaje();
		for ($indice=0; $indice<count($lista); $indice++){
			$current->compra_id = $lista[$indice]["compra_id"];
			$current->fecha = $lista[$indice]["fecha"];
			$current->operacion = $lista[$indice]["operacion"];
			$current->comprobante = $lista[$indice]["comprobante"];
			$current->numero = $lista[$indice]["numero"];
			$current->proveedor_id = $lista[$indice]["proveedor_id"];
			$current->proveedor_nombre = $lista[$indice]["proveedor_nombre"];
			$current->proveedor_documento_tipo = $lista[$indice]["proveedor_documento_tipo"];
			$current->proveedor_documento_numero = $lista[$indice]["proveedor_documento_numero"];
			$current->responsable_id = $lista[$indice]["responsable_id"];
			$current->responsable_nombre = $lista[$indice]["responsable_nombre"];
			$current->responsable_documento_tipo = $lista[$indice]["responsable_documento_tipo"];
			$current->responsable_documento_numero = $lista[$indice]["responsable_documento_numero"];
			$current->moneda_codigo = $lista[$indice]["moneda_codigo"];
			$current->igv_porcentaje = $lista[$indice]["igv_porcentaje"];
			$current->estado_registro = $lista[$indice]["estado_registro"];
			$current->observaciones = $lista[$indice]["observaciones"];
			$current->costo_total = $lista[$indice]["costo_total"];
			$current->activo = $lista[$indice]["activo"];
			$current->proveedor_nombre = $lista[$indice]["proveedor_nombre"];
			$current->proveedor_documento_tipo = $lista[$indice]["proveedor_documento_tipo"];
			$current->proveedor_documento_numero = $lista[$indice]["proveedor_documento_numero"];
			$current->proveedor_direccion = $lista[$indice]["proveedor_direccion"];
			$current->usuario_modificacion = $lista[$indice]["usuario_modificacion"];
			$current->fecha_creacion = $lista[$indice]["fecha_creacion"];
			$current->fecha_modificacion = $lista[$indice]["fecha_modificacion"];
			$current->activo = $lista[$indice]["activo"];
		}
		return $current;
	}

	public function get_compra_id() { return $this->compra_id; }
	public function get_fecha() { return $this->fecha; }
	public function get_operacion() { return $this->operacion; }
	public function get_comprobante() { return $this->comprobante; }
	public function get_numero() { return $this->numero; }
	public function get_proveedor_id() { return $this->proveedor_id; }
	public function get_responsable_id() { return $this->responsable_id; }
	public function get_estado_registro() { return $this->estado_registro; }
	public function get_observaciones() { return $this->observaciones; }
	public function get_costo_total() { return $this->costo_total; }
	public function get_proveedor_nombre() { return $this->proveedor_nombre; }
	public function get_proveedor_documento_tipo() { return $this->proveedor_documento_tipo; }
	public function get_proveedor_documento_numero() { return $this->proveedor_documento_numero; }
	public function get_proveedor_direccion() { return $this->proveedor_direccion; }
	public function get_responsable_nombre() { return $this->responsable_nombre; }
	public function get_responsable_documento_tipo() { return $this->responsable_documento_tipo; }
	public function get_responsable_documento_numero() { return $this->responsable_documento_numero; }
	public function get_responsable_direccion() { return $this->responsable_direccion; }
	public function get_moneda_codigo() { return $this->moneda_codigo; }
	public function get_igv_porcentaje() { return $this->igv_porcentaje; }
	public function get_usuario_modificacion(){  return $this->usuario_modificacion; }
	public function get_fecha_creacion(){  return $this->fecha_creacion; }
	public function get_fecha_modificacion(){  return $this->fecha_modificacion; }
	public function get_activo() { return $this->activo; }
	
	public function set_compra_id($compra_id){ $this->compra_id = $compra_id; }
	public function set_fecha($fecha){ $this->fecha = $fecha; }
	public function set_operacion($operacion){ $this->operacion = $operacion; }
	public function set_comprobante($comprobante){ $this->comprobante = $comprobante; }
	public function set_numero($numero){ $this->numero = $numero; }
	public function set_proveedor_id($proveedor_id){ $this->proveedor_id = $proveedor_id; }
	public function set_responsable_id($responsable_id){ $this->responsable_id = $responsable_id; }
	public function set_estado_registro($estado_registro){ $this->estado_registro = $estado_registro; }
	public function set_observaciones($observaciones){ $this->observaciones = $observaciones; }
	public function set_costo_total($costo_total){ $this->costo_total = $costo_total; }
	public function set_igv_porcentaje($igv_porcentaje){ $this->igv_porcentaje = $igv_porcentaje; }
	public function set_moneda_codigo($moneda_codigo){ $this->moneda_codigo = $moneda_codigo; }
	public function set_usuario_modificacion($usuario_modificacion){ $this->usuario_modificacion = $usuario_modificacion; }
	public function set_fecha_creacion($fecha_creacion){ $this->fecha_creacion = $fecha_creacion; }
	public function set_fecha_modificacion($fecha_modificacion){ $this->fecha_modificacion = $fecha_modificacion; }
	public function set_activo($activo){ $this->activo = $activo; }
	
	public function registrar( $usuario_editor ){
		$conn = new cls_Conexion();
		$respuesta = false;
		$values = array();
		if ( $this->compra_id == 0 ){ // REGISTER
			array_push($values, $this->fecha);
			array_push($values, $this->operacion);
			array_push($values, $this->comprobante);
			array_push($values, $this->numero);
			array_push($values, $this->proveedor_id);
			array_push($values, $this->responsable_id);
			array_push($values, $this->moneda_codigo);
			array_push($values, $this->igv_porcentaje);
			array_push($values, $this->estado_registro);
			array_push($values, $this->observaciones);
			array_push($values, $this->costo_total);
			array_push($values, $usuario_editor);
			$respuesta = $conn->nuevo_registro($this->db_nombretabla, $values);
			$this->db_mensaje = $conn->GetMensaje();
			if ( $respuesta ){
				$this->compra_id = $conn->getlastId();
			}
		} else { // UPDATE
			array_push($values, $this->fecha);
			array_push($values, $this->operacion);
			array_push($values, $this->comprobante);
			array_push($values, $this->numero);
			array_push($values, $this->proveedor_id);
			array_push($values, $this->responsable_id);
			array_push($values, $this->moneda_codigo);
			array_push($values, $this->igv_porcentaje);
			array_push($values, $this->estado_registro);
			array_push($values, $this->observaciones);
			array_push($values, $this->costo_total);
			array_push($values, $usuario_editor);
			array_push($values, $this->compra_id);
			$respuesta = $conn->editar_registro($this->db_nombretabla, $values);
			$this->db_mensaje = $conn->GetMensaje();
		}
		return $respuesta;
	}
	
	public function importar( $usuario_editor ){
		$conn = new cls_Conexion();
		$respuesta = false;
		$values = array();
			array_push($values, $this->compra_id);
			array_push($values, $this->fecha);
			array_push($values, $this->operacion);
			array_push($values, $this->comprobante);
			array_push($values, $this->numero);
			array_push($values, $this->proveedor_id);
			array_push($values, $this->responsable_id);
			array_push($values, $this->moneda_codigo);
			array_push($values, $this->igv_porcentaje);
			array_push($values, $this->estado_registro);
			array_push($values, $this->observaciones);
			array_push($values, $this->costo_total);
			array_push($values, $this->usuario_modificacion);
			array_push($values, $this->fecha_creacion);
			array_push($values, $this->fecha_modificacion);
			array_push($values, $this->activo);
			
			array_push($values, $this->fecha);
			array_push($values, $this->operacion);
			array_push($values, $this->comprobante);
			array_push($values, $this->numero);
			array_push($values, $this->proveedor_id);
			array_push($values, $this->responsable_id);
			array_push($values, $this->moneda_codigo);
			array_push($values, $this->igv_porcentaje);
			array_push($values, $this->estado_registro);
			array_push($values, $this->observaciones);
			array_push($values, $this->costo_total);
			array_push($values, $this->usuario_modificacion);
			array_push($values, $this->fecha_creacion);
			array_push($values, $this->fecha_modificacion);
			array_push($values, $this->activo);
		$respuesta = $conn->importar_registro($this->db_nombretabla, $values);
		$this->db_mensaje = $conn->GetMensaje();
		if ( $respuesta ){
			$this->compra_id = $conn->getlastId();
		};
		return $respuesta;
	}

	public function eliminar( $usuario_editor ){
		$conn = new cls_Conexion();
		$respuesta = false;
		$values = array();
		if ($this->compra_id > 0){ // DELETE
			array_push($values, $usuario_editor);
			array_push($values, $this->compra_id );
			$respuesta = $conn->eliminar_registro($this->db_nombretabla, $values);
			$this->db_mensaje = $conn->GetMensaje();
		} else {
			$this->db_mensaje = "No se puede realizar este proceso";
		}
		return $respuesta;
	}
}

class cls_Group_Compra {

	protected $db_mensaje = "";
	protected $db_nombre_tabla = "vista_compra";
	protected $db_nombres_columnas = "*";
	protected $db_filtro = "1";
	protected $db_agrupar = "";
	protected $db_orden_columna = "nombre";
	protected $db_orden_direccion = "ASC";
	protected $db_cantidad = 0;
	protected $db_filtro_datos = array();
	protected $db_filas = array();
	
	public function __construct(){
		$this->db_nombres_columnas = "compra_id, fecha, operacion, comprobante, numero, proveedor_id, proveedor_nombre, proveedor_documento_tipo, proveedor_documento_numero, responsable_id, responsable_nombre, responsable_documento_tipo, responsable_documento_numero, estado_registro, observaciones, costo_total, proveedor_nombre, proveedor_documento_tipo, proveedor_documento_numero, proveedor_direccion, moneda_codigo, igv_porcentaje, usuario_modificacion, fecha_creacion, fecha_modificacion, activo";
		$this->db_orden_columna = "fecha";
	}

	static public function Export($fecha_min, $fecha_max, $ordendireccion="ASC", $ordencolumna="compra_id", $agrupar=""){
		$conn = new cls_Conexion();
		$current = new cls_Group_Compra();
		$current->db_filtro = "DATE(fecha_creacion) > DATE(?) AND DATE(fecha_creacion) <= DATE(?)";
		$current->db_orden_columna = $ordencolumna;
		$current->db_orden_direccion = $ordendireccion;
		$current->db_agrupar = $agrupar;
		array_push($current->db_filtro_datos, $fecha_min);
		array_push($current->db_filtro_datos, $fecha_max);
		$current->db_cantidad = $conn->contar_filas( $current->db_nombre_tabla, $current->db_filtro, $current->db_filtro_datos, $current->db_agrupar );
		$current->db_mensaje = $conn->getMensaje();
		return $current;
	}
	static public function Buscar($buscar="", $ordendireccion="ASC", $ordencolumna="fecha", $agrupar=""){
		$conn = new cls_Conexion();
		$current = new cls_Group_Compra();
		$buscar = "%".$buscar."%";
		$current->db_filtro = "numero LIKE ? AND activo = true";
		$current->db_orden_columna = $ordencolumna;
		$current->db_orden_direccion = $ordendireccion;
		$current->db_agrupar = $agrupar;
		array_push($current->db_filtro_datos, $buscar );
		$current->db_cantidad = $conn->contar_filas( $current->db_nombre_tabla, $current->db_filtro, $current->db_filtro_datos, $current->db_agrupar );
		$current->db_mensaje = $conn->getMensaje();
		return $current;
	}
	static public function RangoEstadoRegistro($filtro_estado="Todos", $ordendireccion="ASC", $ordencolumna="fecha", $agrupar=""){
		$conn = new cls_Conexion();
		$current = new cls_Group_Compra();
		$current->db_filtro = "(estado_registro LIKE ? OR ? LIKE 'Todos') AND activo = true";
		$current->db_orden_columna = $ordencolumna;
		$current->db_orden_direccion = $ordendireccion;
		$current->db_agrupar = $agrupar;
		array_push($current->db_filtro_datos, $filtro_estado );
		array_push($current->db_filtro_datos, $filtro_estado );
		$current->db_cantidad = $conn->contar_filas( $current->db_nombre_tabla, $current->db_filtro, $current->db_filtro_datos, $current->db_agrupar );
		$current->db_mensaje = $conn->getMensaje();
		return $current;
	}
	static public function RangoFechaEstadoRegistro($fecha_min, $fecha_max, $filtro_estado="Todos", $ordendireccion="ASC", $ordencolumna="fecha", $agrupar=""){
		$conn = new cls_Conexion();
		$current = new cls_Group_Compra();
		$current->db_filtro = "DATE(fecha) >= DATE(?) AND DATE(fecha) <= DATE(?) AND (estado_registro LIKE ? OR ? LIKE 'Todos') AND activo = true";
		$current->db_orden_columna = $ordencolumna;
		$current->db_orden_direccion = $ordendireccion;
		$current->db_agrupar = $agrupar;
		array_push($current->db_filtro_datos, $fecha_min );
		array_push($current->db_filtro_datos, $fecha_max );
		array_push($current->db_filtro_datos, $filtro_estado );
		array_push($current->db_filtro_datos, $filtro_estado );
		$current->db_cantidad = $conn->contar_filas( $current->db_nombre_tabla, $current->db_filtro, $current->db_filtro_datos, $current->db_agrupar );
		$current->db_mensaje = $conn->getMensaje();
		return $current;
	}
	public function cargar_datos( $offset, $cantidad ){
		$conn = new cls_Conexion();
		$this->db_filas = $conn->listar_filas( $this->db_nombre_tabla, $this->db_nombres_columnas, $this->db_orden_columna, $this->db_orden_direccion, $this->db_filtro, $this->db_filtro_datos, $offset, $cantidad, $this->db_agrupar );
		$this->db_mensaje = $conn->GetMensaje();
	}
	public function get_cantidad_cargados(){
		return count($this->db_filas);
	}
	public function get_cantidad(){
		return $this->db_cantidad;
	}
	
	public function get_compra_id($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["compra_id"];
			return $val;
		}
		return 0;
	}
	public function get_fecha($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["fecha"];
			return $val;
		}
		return "";
	}
	public function get_operacion($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["operacion"];
			return $val;
		}
		return "";
	}
	public function get_comprobante($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["comprobante"];
			return $val;
		}
		return "";
	}
	public function get_numero($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["numero"];
			return $val;
		}
		return "";
	}
	public function get_proveedor_id($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["proveedor_id"];
			return $val;
		}
		return "";
	}
	public function get_responsable_id($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["responsable_id"];
			return $val;
		}
		return "";
	}
	public function get_estado_registro($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["estado_registro"];
			return $val;
		}
		return "";
	}
	public function get_observaciones($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["observaciones"];
			return $val;
		}
		return "";
	}
	public function get_costo_total($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["costo_total"];
			return $val;
		}
		return 0;
	}
	public function get_proveedor_nombre($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["proveedor_nombre"];
			return $val;
		}
		return "";
	}
	public function get_proveedor_documento_tipo($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["proveedor_documento_tipo"];
			return $val;
		}
		return "";
	}
	public function get_proveedor_documento_numero($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["proveedor_documento_numero"];
			return $val;
		}
		return "";
	}
	public function get_proveedor_direccion($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["proveedor_direccion"];
			return $val;
		}
		return "";
	}
	public function get_responsable_nombre($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["responsable_nombre"];
			return $val;
		}
		return "";
	}
	public function get_responsable_documento_tipo($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["responsable_documento_tipo"];
			return $val;
		}
		return "";
	}
	public function get_responsable_documento_numero($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["responsable_documento_numero"];
			return $val;
		}
		return "";
	}
	public function get_moneda_codigo($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["moneda_codigo"];
			return $val;
		}
		return "";
	}
	public function get_igv_porcentaje($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["igv_porcentaje"];
			return $val;
		}
		return "";
	}
	public function get_usuario_modificacion($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["usuario_modificacion"];
			return $val;
		}
		return 0;
	}
	public function get_fecha_creacion($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["fecha_creacion"];
			return $val;
		}
		return "";
	}
	public function get_fecha_modificacion($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["fecha_modificacion"];
			return $val;
		}
		return "";
	}
	public function get_activo($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["activo"];
			return $val;
		}
		return "";
	}
};
?>		
